type AnyFn = (...args: any[]) => any;
type InstrumentFunction = <X extends AnyFn>(name: string, fn: X) => X;

type Provider<O> = (() => O | Promise<O>);
type inferProvider<T> = T extends Provider<infer V> ? Awaited<V> : T;
type Submodule<Provide, Dependent> = (dependent: Dependent) => Provide | Promise<Provide>;
type Executable<Services, Input, Output> = (services: Services, input: Input) => Output | Promise<Output>;
type ExecutableOptions<InitArgs> = {
    eager?: boolean;
    initArgs?: InitArgs;
    instrument?: InstrumentFunction;
};
type Executor<Services> = {
    execute: <Input extends any, Output>(executable: Executable<Services, inferProvider<Input>, Output>, input?: Input) => Promise<Output>;
    prepare: <Input extends any, Output>(executable: Executable<Services, inferProvider<Input>, Output>) => (input: Input) => Promise<Output>;
    get(): Promise<Services>;
};
declare const prepareExecutable: <Services, Dependent>(submoduleDef: Submodule<Services, inferProvider<Dependent>>, options?: ExecutableOptions<Dependent> | undefined) => Executor<Services>;

export { ExecutableOptions, Executor, Submodule, prepareExecutable };
